Index: /palm/trunk/SOURCE/advec_ws.f90
===================================================================
--- /palm/trunk/SOURCE/advec_ws.f90	(revision 4345)
+++ /palm/trunk/SOURCE/advec_ws.f90	(revision 4346)
@@ -25,4 +25,8 @@
 ! -----------------
 ! $Id$
+! Introduction of wall_flags_total_0, which currently sets bits based on static
+! topography information used in wall_flags_static_0
+! 
+! 4340 2019-12-16 08:17:03Z Giersch
 ! Topography closed channel flow with symmetric boundaries implemented 
 ! 
@@ -196,5 +200,5 @@
                nzb_max,                                                        &
                nzt,                                                            &
-               wall_flags_static_0
+               wall_flags_total_0
 
     USE grid_variables,                                                        &
@@ -418,5 +422,5 @@
 !--             u component - x-direction
 !--             WS1 (0), WS3 (1), WS5 (2)
-                IF ( .NOT. BTEST(wall_flags_static_0(k,j,i+1),1)  .OR.         &
+                IF ( .NOT. BTEST(wall_flags_total_0(k,j,i+1),1)  .OR.          &
                          ( ( bc_dirichlet_l .OR. bc_radiation_l )              &
                            .AND. i <= nxlu  )    .OR.                          &
@@ -425,7 +429,7 @@
                 THEN                                                           
                     advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 0 )      
-                ELSEIF ( ( .NOT. BTEST(wall_flags_static_0(k,j,i+2),1)  .AND.  &
-                                 BTEST(wall_flags_static_0(k,j,i+1),1)  .OR.   &
-                           .NOT. BTEST(wall_flags_static_0(k,j,i-1),1) )       &
+                ELSEIF ( ( .NOT. BTEST(wall_flags_total_0(k,j,i+2),1)  .AND.   &
+                                 BTEST(wall_flags_total_0(k,j,i+1),1)  .OR.    &
+                           .NOT. BTEST(wall_flags_total_0(k,j,i-1),1) )        &
                                                      .OR.                      &
                          ( ( bc_dirichlet_r .OR. bc_radiation_r )              &
@@ -438,7 +442,7 @@
 !--                Clear flag for WS1                                          
                    advc_flags_m(k,j,i) = IBCLR( advc_flags_m(k,j,i), 0 )       
-                ELSEIF ( BTEST(wall_flags_static_0(k,j,i+1),1)  .AND.          &
-                         BTEST(wall_flags_static_0(k,j,i+2),1)  .AND.          &
-                         BTEST(wall_flags_static_0(k,j,i-1),1) )               &
+                ELSEIF ( BTEST(wall_flags_total_0(k,j,i+1),1)  .AND.          &
+                         BTEST(wall_flags_total_0(k,j,i+2),1)  .AND.          &
+                         BTEST(wall_flags_total_0(k,j,i-1),1) )               &
                 THEN                                                           
                    advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 2 )       
@@ -449,6 +453,6 @@
 !                                                                              
 !--             u component - y-direction                                      
-!--             WS1 (3), WS3 (4), WS5 (5)                                      
-                IF ( .NOT. BTEST(wall_flags_static_0(k,j+1,i),1)   .OR.        &
+!--             WS1 (3), WS3 (4), WS5 (5)                                       
+                IF ( .NOT. BTEST(wall_flags_total_0(k,j+1,i),1)   .OR.         &
                          ( ( bc_dirichlet_s .OR. bc_radiation_s )              &
                            .AND. j == nys   )    .OR.                          &
@@ -457,7 +461,7 @@
                 THEN                                                           
                    advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 3 )       
-                ELSEIF ( ( .NOT. BTEST(wall_flags_static_0(k,j+2,i),1)  .AND.  &
-                                 BTEST(wall_flags_static_0(k,j+1,i),1)  .OR.   &
-                           .NOT. BTEST(wall_flags_static_0(k,j-1,i),1) )       &
+                ELSEIF ( ( .NOT. BTEST(wall_flags_total_0(k,j+2,i),1)  .AND.   &
+                                 BTEST(wall_flags_total_0(k,j+1,i),1)  .OR.    &
+                           .NOT. BTEST(wall_flags_total_0(k,j-1,i),1) )        &
                                                      .OR.                      &
                          ( ( bc_dirichlet_s .OR. bc_radiation_s )              &
@@ -470,7 +474,7 @@
 !--                Clear flag for WS1                                          
                    advc_flags_m(k,j,i) = IBCLR( advc_flags_m(k,j,i), 3 )       
-                ELSEIF ( BTEST(wall_flags_static_0(k,j+1,i),1)  .AND.          &
-                         BTEST(wall_flags_static_0(k,j+2,i),1)  .AND.          &
-                         BTEST(wall_flags_static_0(k,j-1,i),1) )               &
+                ELSEIF ( BTEST(wall_flags_total_0(k,j+1,i),1)  .AND.          &
+                         BTEST(wall_flags_total_0(k,j+2,i),1)  .AND.          &
+                         BTEST(wall_flags_total_0(k,j-1,i),1) )               &
                 THEN                                                           
                    advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 5 )       
@@ -500,32 +504,32 @@
                                                                                
                 flag_set = .FALSE.                                             
-                IF ( ( .NOT. BTEST(wall_flags_static_0(k-1,j,i),1)       .AND.     &
-                             BTEST(wall_flags_static_0(k,j,i),1)         .AND.     &
-                             BTEST(wall_flags_static_0(k+1,j,i),1) )     .OR.      &
-                     ( .NOT. BTEST(wall_flags_static_0(k_pp,j,i),1)      .AND.     &                              
-                             BTEST(wall_flags_static_0(k+1,j,i),1)       .AND.     &
-                             BTEST(wall_flags_static_0(k,j,i),1) )       .OR.      &
-                     ( k == nzt .AND. symmetry_flag == 0 ) )                       &
+                IF ( ( .NOT. BTEST(wall_flags_total_0(k-1,j,i),1)       .AND.     &
+                             BTEST(wall_flags_total_0(k,j,i),1)         .AND.     &
+                             BTEST(wall_flags_total_0(k+1,j,i),1) )     .OR.      &
+                     ( .NOT. BTEST(wall_flags_total_0(k_pp,j,i),1)      .AND.     &                              
+                             BTEST(wall_flags_total_0(k+1,j,i),1)       .AND.     &
+                             BTEST(wall_flags_total_0(k,j,i),1) )       .OR.      &
+                     ( k == nzt .AND. symmetry_flag == 0 ) )                      &
                 THEN                                                           
                    advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 6 )       
                    flag_set = .TRUE.                                           
-                ELSEIF ( ( .NOT. BTEST(wall_flags_static_0(k_mm,j,i),1)    .OR.    &
-                           .NOT. BTEST(wall_flags_static_0(k_ppp,j,i),1) ) .AND.   & 
-                                 BTEST(wall_flags_static_0(k-1,j,i),1)     .AND.   &
-                                 BTEST(wall_flags_static_0(k,j,i),1)       .AND.   &
-                                 BTEST(wall_flags_static_0(k+1,j,i),1)     .AND.   &
-                                 BTEST(wall_flags_static_0(k_pp,j,i),1)    .AND.   &
-                           .NOT. flag_set                                  .OR.    & 
-                         ( k == nzt - 1 .AND. symmetry_flag == 0 ) )               &
+                ELSEIF ( ( .NOT. BTEST(wall_flags_total_0(k_mm,j,i),1)    .OR.    &
+                           .NOT. BTEST(wall_flags_total_0(k_ppp,j,i),1) ) .AND.   & 
+                                 BTEST(wall_flags_total_0(k-1,j,i),1)     .AND.   &
+                                 BTEST(wall_flags_total_0(k,j,i),1)       .AND.   &
+                                 BTEST(wall_flags_total_0(k+1,j,i),1)     .AND.   &
+                                 BTEST(wall_flags_total_0(k_pp,j,i),1)    .AND.   &
+                           .NOT. flag_set                                  .OR.   & 
+                         ( k == nzt - 1 .AND. symmetry_flag == 0 ) )              &
                 THEN                                                           
                    advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 7 )       
                    flag_set = .TRUE.                                           
-                ELSEIF ( BTEST(wall_flags_static_0(k_mm,j,i),1)            .AND.   &
-                         BTEST(wall_flags_static_0(k-1,j,i),1)             .AND.   &
-                         BTEST(wall_flags_static_0(k,j,i),1)               .AND.   &
-                         BTEST(wall_flags_static_0(k+1,j,i),1)             .AND.   &
-                         BTEST(wall_flags_static_0(k_pp,j,i),1)            .AND.   &
-                         BTEST(wall_flags_static_0(k_ppp,j,i),1)           .AND.   &
-                         .NOT. flag_set )                                          &
+                ELSEIF ( BTEST(wall_flags_total_0(k_mm,j,i),1)            .AND.   &
+                         BTEST(wall_flags_total_0(k-1,j,i),1)             .AND.   &
+                         BTEST(wall_flags_total_0(k,j,i),1)               .AND.   &
+                         BTEST(wall_flags_total_0(k+1,j,i),1)             .AND.   &
+                         BTEST(wall_flags_total_0(k_pp,j,i),1)            .AND.   &
+                         BTEST(wall_flags_total_0(k_ppp,j,i),1)           .AND.   &
+                         .NOT. flag_set )                                         &
                 THEN
                    advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 8 )
@@ -549,5 +553,5 @@
 !--             v component - x-direction
 !--             WS1 (9), WS3 (10), WS5 (11)
-                IF ( .NOT. BTEST(wall_flags_static_0(k,j,i+1),2)  .OR.         &
+                IF ( .NOT. BTEST(wall_flags_total_0(k,j,i+1),2)  .OR.          &
                          ( ( bc_dirichlet_l .OR. bc_radiation_l )              &
                            .AND. i == nxl   )    .OR.                          &
@@ -558,7 +562,7 @@
 !                                                                              
 !--             WS3                                                            
-                ELSEIF ( ( .NOT. BTEST(wall_flags_static_0(k,j,i+2),2)   .AND. &
-                                 BTEST(wall_flags_static_0(k,j,i+1),2) ) .OR.  &
-                           .NOT. BTEST(wall_flags_static_0(k,j,i-1),2)         &
+                ELSEIF ( ( .NOT. BTEST(wall_flags_total_0(k,j,i+2),2)   .AND.  &
+                                 BTEST(wall_flags_total_0(k,j,i+1),2) ) .OR.   &
+                           .NOT. BTEST(wall_flags_total_0(k,j,i-1),2)          &
                                                  .OR.                          &
                          ( ( bc_dirichlet_r .OR. bc_radiation_r )              &
@@ -571,7 +575,7 @@
 !--                Clear flag for WS1                                          
                    advc_flags_m(k,j,i) = IBCLR( advc_flags_m(k,j,i), 9 )     
-                ELSEIF ( BTEST(wall_flags_static_0(k,j,i+1),2)  .AND.          &
-                         BTEST(wall_flags_static_0(k,j,i+2),2)  .AND.          &
-                         BTEST(wall_flags_static_0(k,j,i-1),2) )               &
+                ELSEIF ( BTEST(wall_flags_total_0(k,j,i+1),2)  .AND.           &
+                         BTEST(wall_flags_total_0(k,j,i+2),2)  .AND.           &
+                         BTEST(wall_flags_total_0(k,j,i-1),2) )                &
                 THEN                                                           
                    advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 11 )      
@@ -583,5 +587,5 @@
 !--             v component - y-direction                                      
 !--             WS1 (12), WS3 (13), WS5 (14)                                   
-                IF ( .NOT. BTEST(wall_flags_static_0(k,j+1,i),2) .OR.          &
+                IF ( .NOT. BTEST(wall_flags_total_0(k,j+1,i),2) .OR.           &
                          ( ( bc_dirichlet_s .OR. bc_radiation_s )              &
                            .AND. j <= nysv  )    .OR.                          &
@@ -590,7 +594,7 @@
                 THEN                                                           
                    advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 12 )      
-                ELSEIF ( ( .NOT. BTEST(wall_flags_static_0(k,j+2,i),2)  .AND.  &
-                                 BTEST(wall_flags_static_0(k,j+1,i),2)  .OR.   &
-                           .NOT. BTEST(wall_flags_static_0(k,j-1,i),2) )       &
+                ELSEIF ( ( .NOT. BTEST(wall_flags_total_0(k,j+2,i),2)  .AND.   &
+                                 BTEST(wall_flags_total_0(k,j+1,i),2)  .OR.    &
+                           .NOT. BTEST(wall_flags_total_0(k,j-1,i),2) )        &
                                                      .OR.                      &
                          ( (  bc_dirichlet_s .OR. bc_radiation_s )             &
@@ -603,8 +607,8 @@
 !--                Clear flag for WS1                                          
                    advc_flags_m(k,j,i) = IBCLR( advc_flags_m(k,j,i), 12 )      
-                ELSEIF ( BTEST(wall_flags_static_0(k,j+1,i),2)  .AND.          &
-                         BTEST(wall_flags_static_0(k,j+2,i),2)  .AND.          &
-                         BTEST(wall_flags_static_0(k,j-1,i),2) )               & 
-                THEN
+                ELSEIF ( BTEST(wall_flags_total_0(k,j+1,i),2)  .AND.           &
+                         BTEST(wall_flags_total_0(k,j+2,i),2)  .AND.           &
+                         BTEST(wall_flags_total_0(k,j-1,i),2) )                & 
+                THEN                                                          
                    advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 14 )
 !
@@ -633,32 +637,32 @@
                 
                 flag_set = .FALSE.
-                IF ( ( .NOT. BTEST(wall_flags_static_0(k-1,j,i),2)          .AND.     &
-                             BTEST(wall_flags_static_0(k,j,i),2)            .AND.     &
-                             BTEST(wall_flags_static_0(k+1,j,i),2) )        .OR.      &
-                     ( .NOT. BTEST(wall_flags_static_0(k_pp,j,i),2)         .AND.     &                              
-                             BTEST(wall_flags_static_0(k+1,j,i),2)          .AND.     &
-                             BTEST(wall_flags_static_0(k,j,i),2) )          .OR.      &
-                     ( k == nzt .AND. symmetry_flag == 0 ) )                          &
+                IF ( ( .NOT. BTEST(wall_flags_total_0(k-1,j,i),2)          .AND.   &
+                             BTEST(wall_flags_total_0(k,j,i),2)            .AND.   &
+                             BTEST(wall_flags_total_0(k+1,j,i),2) )        .OR.    &
+                     ( .NOT. BTEST(wall_flags_total_0(k_pp,j,i),2)         .AND.   &                              
+                             BTEST(wall_flags_total_0(k+1,j,i),2)          .AND.   &
+                             BTEST(wall_flags_total_0(k,j,i),2) )          .OR.    &
+                     ( k == nzt .AND. symmetry_flag == 0 ) )                       &
                 THEN                                                           
                    advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 15 )      
                    flag_set = .TRUE.                                           
-                ELSEIF ( ( .NOT. BTEST(wall_flags_static_0(k_mm,j,i),2)    .OR.       &
-                           .NOT. BTEST(wall_flags_static_0(k_ppp,j,i),2) ) .AND.      & 
-                                 BTEST(wall_flags_static_0(k-1,j,i),2)     .AND.      &
-                                 BTEST(wall_flags_static_0(k,j,i),2)       .AND.      &
-                                 BTEST(wall_flags_static_0(k+1,j,i),2)     .AND.      &
-                                 BTEST(wall_flags_static_0(k_pp,j,i),2)    .AND.      &
-                           .NOT. flag_set                                  .OR.       & 
-                         ( k == nzt - 1 .AND. symmetry_flag == 0 ) )                  &
+                ELSEIF ( ( .NOT. BTEST(wall_flags_total_0(k_mm,j,i),2)    .OR.     &
+                           .NOT. BTEST(wall_flags_total_0(k_ppp,j,i),2) ) .AND.    & 
+                                 BTEST(wall_flags_total_0(k-1,j,i),2)     .AND.    &
+                                 BTEST(wall_flags_total_0(k,j,i),2)       .AND.    &
+                                 BTEST(wall_flags_total_0(k+1,j,i),2)     .AND.    &
+                                 BTEST(wall_flags_total_0(k_pp,j,i),2)    .AND.    &
+                           .NOT. flag_set                                  .OR.    & 
+                         ( k == nzt - 1 .AND. symmetry_flag == 0 ) )               &
                 THEN                                                           
                    advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 16 )      
                    flag_set = .TRUE.                                           
-                ELSEIF ( BTEST(wall_flags_static_0(k_mm,j,i),2)             .AND.     &
-                         BTEST(wall_flags_static_0(k-1,j,i),2)              .AND.     &
-                         BTEST(wall_flags_static_0(k,j,i),2)                .AND.     &
-                         BTEST(wall_flags_static_0(k+1,j,i),2)              .AND.     &
-                         BTEST(wall_flags_static_0(k_pp,j,i),2)             .AND.     &
-                         BTEST(wall_flags_static_0(k_ppp,j,i),2)            .AND.     &
-                         .NOT. flag_set )                                             &
+                ELSEIF ( BTEST(wall_flags_total_0(k_mm,j,i),2)             .AND.   &
+                         BTEST(wall_flags_total_0(k-1,j,i),2)              .AND.   &
+                         BTEST(wall_flags_total_0(k,j,i),2)                .AND.   &
+                         BTEST(wall_flags_total_0(k+1,j,i),2)              .AND.   &
+                         BTEST(wall_flags_total_0(k_pp,j,i),2)             .AND.   &
+                         BTEST(wall_flags_total_0(k_ppp,j,i),2)            .AND.   &
+                         .NOT. flag_set )                                          &
                 THEN
                    advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 17 )
@@ -682,5 +686,5 @@
 !--             w component - x-direction
 !--             WS1 (18), WS3 (19), WS5 (20)
-                IF ( .NOT. BTEST(wall_flags_static_0(k,j,i+1),3) .OR.          &
+                IF ( .NOT. BTEST(wall_flags_total_0(k,j,i+1),3) .OR.           &
                          ( (  bc_dirichlet_l .OR. bc_radiation_l )             &
                            .AND. i == nxl   )    .OR.                          &
@@ -689,7 +693,7 @@
                 THEN                                                           
                    advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 18 )     
-                ELSEIF ( ( .NOT. BTEST(wall_flags_static_0(k,j,i+2),3)  .AND.  &
-                                 BTEST(wall_flags_static_0(k,j,i+1),3)  .OR.   &
-                           .NOT. BTEST(wall_flags_static_0(k,j,i-1),3) )       &
+                ELSEIF ( ( .NOT. BTEST(wall_flags_total_0(k,j,i+2),3)  .AND.   &
+                                 BTEST(wall_flags_total_0(k,j,i+1),3)  .OR.    &
+                           .NOT. BTEST(wall_flags_total_0(k,j,i-1),3) )        &
                                                      .OR.                      &
                          ( ( bc_dirichlet_r .OR. bc_radiation_r )              &
@@ -702,7 +706,7 @@
 !--                Clear flag for WS1                                          
                    advc_flags_m(k,j,i) = IBCLR( advc_flags_m(k,j,i), 18 )      
-                ELSEIF ( BTEST(wall_flags_static_0(k,j,i+1),3)  .AND.          &
-                         BTEST(wall_flags_static_0(k,j,i+2),3)  .AND.          &
-                         BTEST(wall_flags_static_0(k,j,i-1),3) )               &
+                ELSEIF ( BTEST(wall_flags_total_0(k,j,i+1),3)  .AND.           &
+                         BTEST(wall_flags_total_0(k,j,i+2),3)  .AND.           &
+                         BTEST(wall_flags_total_0(k,j,i-1),3) )                &
                 THEN                                                           
                    advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i),20 )       
@@ -714,5 +718,5 @@
 !--             w component - y-direction                                      
 !--             WS1 (21), WS3 (22), WS5 (23)                                   
-                IF ( .NOT. BTEST(wall_flags_static_0(k,j+1,i),3) .OR.          &
+                IF ( .NOT. BTEST(wall_flags_total_0(k,j+1,i),3) .OR.           &
                          ( ( bc_dirichlet_s .OR. bc_radiation_s )              &
                            .AND. j == nys   )    .OR.                          &
@@ -721,7 +725,7 @@
                 THEN                                                           
                    advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 21 )     
-                ELSEIF ( ( .NOT. BTEST(wall_flags_static_0(k,j+2,i),3)  .AND.  &
-                                 BTEST(wall_flags_static_0(k,j+1,i),3)  .OR.   &
-                           .NOT. BTEST(wall_flags_static_0(k,j-1,i),3) )       &
+                ELSEIF ( ( .NOT. BTEST(wall_flags_total_0(k,j+2,i),3)  .AND.   &
+                                 BTEST(wall_flags_total_0(k,j+1,i),3)  .OR.    &
+                           .NOT. BTEST(wall_flags_total_0(k,j-1,i),3) )        &
                                                      .OR.                      &
                          ( ( bc_dirichlet_s .OR. bc_radiation_s )              &
@@ -733,8 +737,8 @@
 !                                                                              
 !--                Clear flag for WS1                                          
-                   advc_flags_m(k,j,i) = IBCLR( advc_flags_m(k,j,i), 21 )      
-                ELSEIF ( BTEST(wall_flags_static_0(k,j+1,i),3)  .AND.          &
-                         BTEST(wall_flags_static_0(k,j+2,i),3)  .AND.          &
-                         BTEST(wall_flags_static_0(k,j-1,i),3) )               &
+                   advc_flags_m(k,j,i) = IBCLR( advc_flags_m(k,j,i), 21 )       
+                ELSEIF ( BTEST(wall_flags_total_0(k,j+1,i),3)  .AND.           &
+                         BTEST(wall_flags_total_0(k,j+2,i),3)  .AND.           &
+                         BTEST(wall_flags_total_0(k,j-1,i),3) )                &
                 THEN                                                           
                    advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 23 )
@@ -765,9 +769,9 @@
                 
                 flag_set = .FALSE.                                        
-                IF ( ( .NOT. BTEST(wall_flags_static_0(k,j,i),3)          .AND.     &
-                             BTEST(wall_flags_static_0(k+1,j,i),3) )      .OR.      &
-                     ( .NOT. BTEST(wall_flags_static_0(k+1,j,i),3)        .AND.     &
-                             BTEST(wall_flags_static_0(k,j,i),3) )        .OR.      &        
-                     k == nzt -1 )                                                  &
+                IF ( ( .NOT. BTEST(wall_flags_total_0(k,j,i),3)          .AND.   &
+                             BTEST(wall_flags_total_0(k+1,j,i),3) )      .OR.    &
+                     ( .NOT. BTEST(wall_flags_total_0(k+1,j,i),3)        .AND.   &
+                             BTEST(wall_flags_total_0(k,j,i),3) )        .OR.    &        
+                     k == nzt -1 )                                               &
                 THEN
 !
@@ -779,22 +783,22 @@
                    advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 24 )
                    flag_set = .TRUE.
-                ELSEIF ( ( .NOT. BTEST(wall_flags_static_0(k-1,j,i),3)    .AND.     &
-                                 BTEST(wall_flags_static_0(k,j,i),3)      .AND.     &
-                                 BTEST(wall_flags_static_0(k+1,j,i),3)    .AND.     &
-                                 BTEST(wall_flags_static_0(k_pp,j,i),3) ) .OR.      &
-                         ( .NOT. BTEST(wall_flags_static_0(k_pp,j,i),3)   .AND.     &
-                                 BTEST(wall_flags_static_0(k+1,j,i),3)    .AND.     &
-                                 BTEST(wall_flags_static_0(k,j,i),3)      .AND.     &
-                                 BTEST(wall_flags_static_0(k-1,j,i),3) )  .AND.     &
-                           .NOT. flag_set                          .OR.             & 
-                         k == nzt - 2 )                                             &
+                ELSEIF ( ( .NOT. BTEST(wall_flags_total_0(k-1,j,i),3)    .AND.   &
+                                 BTEST(wall_flags_total_0(k,j,i),3)      .AND.   &
+                                 BTEST(wall_flags_total_0(k+1,j,i),3)    .AND.   &
+                                 BTEST(wall_flags_total_0(k_pp,j,i),3) ) .OR.    &
+                         ( .NOT. BTEST(wall_flags_total_0(k_pp,j,i),3)   .AND.   &
+                                 BTEST(wall_flags_total_0(k+1,j,i),3)    .AND.   &
+                                 BTEST(wall_flags_total_0(k,j,i),3)      .AND.   &
+                                 BTEST(wall_flags_total_0(k-1,j,i),3) )  .AND.   &
+                           .NOT. flag_set                          .OR.          & 
+                         k == nzt - 2 )                                          &
                 THEN                                                           
                    advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 25 )      
                    flag_set = .TRUE.                                           
-                ELSEIF ( BTEST(wall_flags_static_0(k-1,j,i),3)            .AND.     &
-                         BTEST(wall_flags_static_0(k,j,i),3)              .AND.     &
-                         BTEST(wall_flags_static_0(k+1,j,i),3)            .AND.     &
-                         BTEST(wall_flags_static_0(k_pp,j,i),3)           .AND.     &
-                         .NOT. flag_set )                                           &
+                ELSEIF ( BTEST(wall_flags_total_0(k-1,j,i),3)            .AND.   &
+                         BTEST(wall_flags_total_0(k,j,i),3)              .AND.   &
+                         BTEST(wall_flags_total_0(k+1,j,i),3)            .AND.   &
+                         BTEST(wall_flags_total_0(k_pp,j,i),3)           .AND.   &
+                         .NOT. flag_set )                                        &
                 THEN                                                                
                    advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 26 )
@@ -867,33 +871,33 @@
           DO  j = nys, nyn
              DO  k = nzb+1, nzt
-                IF ( .NOT.  BTEST(wall_flags_static_0(k,j,i),0) )  CYCLE
+                IF ( .NOT.  BTEST(wall_flags_total_0(k,j,i),0) )  CYCLE
 !
 !--             scalar - x-direction
 !--             WS1 (0), WS3 (1), WS5 (2)
-                IF ( ( .NOT. BTEST(wall_flags_static_0(k,j,i+1),0)      .OR.          &
-                       .NOT. BTEST(wall_flags_static_0(k,j,i+2),0)      .OR.          &   
-                       .NOT. BTEST(wall_flags_static_0(k,j,i-1),0) )    .OR.          &
-                       ( non_cyclic_l  .AND.  i == 0  )                 .OR.          &
+                IF ( ( .NOT. BTEST(wall_flags_total_0(k,j,i+1),0)      .OR.      &
+                       .NOT. BTEST(wall_flags_total_0(k,j,i+2),0)      .OR.      &   
+                       .NOT. BTEST(wall_flags_total_0(k,j,i-1),0) )    .OR.      &
+                       ( non_cyclic_l  .AND.  i == 0  )                .OR.      &
                        ( non_cyclic_r  .AND.  i == nx ) )  THEN           
                  advc_flag(k,j,i) = IBSET( advc_flag(k,j,i), 0 )             
-                ELSEIF ( ( .NOT. BTEST(wall_flags_static_0(k,j,i+3),0)  .AND.         &
-                                 BTEST(wall_flags_static_0(k,j,i+1),0)  .AND.         &
-                                 BTEST(wall_flags_static_0(k,j,i+2),0)  .AND.         &
-                                 BTEST(wall_flags_static_0(k,j,i-1),0)                &
-                         )                       .OR.                                 &
-                         ( .NOT. BTEST(wall_flags_static_0(k,j,i-2),0)  .AND.         &
-                                 BTEST(wall_flags_static_0(k,j,i+1),0)  .AND.         &
-                                 BTEST(wall_flags_static_0(k,j,i+2),0)  .AND.         &
-                                 BTEST(wall_flags_static_0(k,j,i-1),0)                &
-                         )                                                            &
-                                                 .OR.                                 &
-                         ( non_cyclic_r  .AND.  i == nx-1 )  .OR.                     &
+                ELSEIF ( ( .NOT. BTEST(wall_flags_total_0(k,j,i+3),0)  .AND.     &
+                                 BTEST(wall_flags_total_0(k,j,i+1),0)  .AND.     &
+                                 BTEST(wall_flags_total_0(k,j,i+2),0)  .AND.     &
+                                 BTEST(wall_flags_total_0(k,j,i-1),0)            &
+                         )                       .OR.                            &
+                         ( .NOT. BTEST(wall_flags_total_0(k,j,i-2),0)  .AND.     &
+                                 BTEST(wall_flags_total_0(k,j,i+1),0)  .AND.     &
+                                 BTEST(wall_flags_total_0(k,j,i+2),0)  .AND.     &
+                                 BTEST(wall_flags_total_0(k,j,i-1),0)            &
+                         )                                                       &
+                                                 .OR.                            &
+                         ( non_cyclic_r  .AND.  i == nx-1 )  .OR.                &
                          ( non_cyclic_l  .AND.  i == 1    ) )  THEN           
                    advc_flag(k,j,i) = IBSET( advc_flag(k,j,i), 1 )             
-                ELSEIF ( BTEST(wall_flags_static_0(k,j,i+1),0)           .AND.        &
-                         BTEST(wall_flags_static_0(k,j,i+2),0)           .AND.        &
-                         BTEST(wall_flags_static_0(k,j,i+3),0)           .AND.        &
-                         BTEST(wall_flags_static_0(k,j,i-1),0)           .AND.        &
-                         BTEST(wall_flags_static_0(k,j,i-2),0) )                      &
+                ELSEIF ( BTEST(wall_flags_total_0(k,j,i+1),0)           .AND.    &
+                         BTEST(wall_flags_total_0(k,j,i+2),0)           .AND.    &
+                         BTEST(wall_flags_total_0(k,j,i+3),0)           .AND.    &
+                         BTEST(wall_flags_total_0(k,j,i-1),0)           .AND.    &
+                         BTEST(wall_flags_total_0(k,j,i-2),0) )                  &
                 THEN                                                           
                    advc_flag(k,j,i) = IBSET( advc_flag(k,j,i), 2 )             
